import time
import os
import RPi.GPIO as GPIO

GPIO.setmode(GPIO.BOARD)

#funzione che legge il dato dal bus SPI per l'ADS7816

def readadc(clock, miso, cs):
    GPIO.output(cs, True) #pone CS a 1 per bloccare la partenza
    GPIO.output(clock, False) #pone il clock a livello basso
    GPIO.output(cs, False) #pone cs a livello basso: inizia la conversione

    GPIO.output(clock, True)
    GPIO.output(clock, False) #ciclo per effettuare la conversione ADC

    adcres = 0 #inizializzazione variabile contenente valore

    #si comincia la lettura vera e propria
    for i in range(13): #un bit di null e 12bit per il dato
        GPIO.output(clock, True)
        GPIO.output(clock, False) #ciclo per passare al dato successivo
        adcres <<= 1
        if (GPIO.input(miso)):
            adcres |= 0x1 #se il bit è positivo incrementa il valore
    GPIO.output(cs, True) #alza cs per terminare l'invio
    adcres /= 2 #taglia il bit null
    return adcres

#inizializza i pin dell'SPI
GPIO.setup(21, GPIO.IN)  #miso
GPIO.setup(23, GPIO.OUT) #clock
GPIO.setup(24, GPIO.OUT) #cs 0

#fa partire la conversione vera e propria richiamando la funzione
while True:
    adcacq = readadc(23, 21, 24)
    voltage = adcacq * (5 / 4096)
    print(voltage, 'V')
    time.sleep(5)
